# define support vector machine (svm) functions
# single_CpG_based svm function
f1= function(j,a1,a2,a3)
    {
      H= a1[,j]
      W= a2[,j]

       if (sum(H & W, na.rm=T)< 2) 
          {V3= rep(NA,length(a3[,j]))}

      else 
          {
          mod_svm=svm(H,W,type="eps",kernel="radial")
          V1 = a3[,j]
          V1[!is.na(V1)] = predict(mod_svm,a3[,j],na.rm=T)
          V3= V1
          }
     }
# correlating_CpG_based svm function
f2= function(j,a1,a2,a3,correlated_CpG_number)
    {
      j_CpG_name= colnames(a1)[j]
      H_1= a1[,-j]
      
      all_pvalues= sapply(1:dim(H_1)[2],f3, H_1, a2[,j]) # calculate pvalues
      small_pvalue_id=  which(rank(all_pvalues) < (correlated_CpG_number-1)) # find (correlated_CpG_number-1) CpGs with smallest pvalues
      select_CpG_names= colnames(H_1)[small_pvalue_id]
      
      V3= c()

      for (i in 1:dim(a3)[1])
      {
      H= a1[,c(j_CpG_name,select_CpG_names)] # select new predictors
      W= a2[,j_CpG_name]
      V1= a3[i,c(j_CpG_name,select_CpG_names)]
      

      if (sum(is.na(V1))!=0)     # remove the predictor with NA in testing and training data
         {
          na_index= which(is.na(V1))
          V1= V1[-na_index]
          H= H[,-na_index]
         }
      mod_svm=svm(H,W,type="eps",kernel="radial")
      V3[i] = predict(mod_svm,V1,na.rm=T)
      
      }
      
      V3
     }
# calculate pvalues in surrogate data corresponding to the ith CpG in target data, using lm model
f3= function(k,X1,Y1){
	
	lm_mod= lm(Y1~ X1[,k])
	p_val= summary(lm_mod)$coefficients[2,4]
    }



###################################################################################
# Input parameters for the mctp() function
#  x is file name of surrogate training data
#  y is file name of target training data
#  z is file name of surrogate testing data
#  u is output file name of predicted target tissue data by single_CpG_based svm
#  v is output file name of predicted target tissue data by correlating_CpG_based svm

mctp= function(x,y,z,u,v)
    {

# read Surrogate, Target training data and surrogate testing data

  Surrogate_training_data= read.table(x,header= T)

  Target_training_data= read.table(y,header= T)

  Surrogate_testing_data= read.table(z,header= T)

  n=dim(Surrogate_testing_data)[1]  # number of samples
  m=dim(Surrogate_testing_data)[2]  # number of CpGs
  correlated_CpG_number= 6 # number of correlated CpG sites selected

  library(e1071) # load svm package

  Predicted_target_single_svm= sapply(1:m,f1,Surrogate_training_data,Target_training_data,Surrogate_testing_data) # predicted target tissue data using single_CpG_based svm

  Predicted_target_correlating_svm= sapply(1:m,f2,Surrogate_training_data,Target_training_data,Surrogate_testing_data,correlated_CpG_number) # predicted target tissue data using correlated_CpG_based svm
  
######################################################################
# save predicted target data using svm

  rownames(Predicted_target_single_svm)=rownames(Surrogate_testing_data)
  colnames(Predicted_target_single_svm)=colnames(Surrogate_testing_data)

  write.table(Predicted_target_single_svm, file=u)

  rownames(Predicted_target_correlating_svm)=rownames(Surrogate_testing_data)
  colnames(Predicted_target_correlating_svm)=colnames(Surrogate_testing_data)

  write.table(Predicted_target_correlating_svm, file=v)
#end
    }
######################################################################

